<template>
  <div class="hor-bar-chart">

    <div class="hor-bar-chart__title-row">
      <div class="hor-bar-chart__title-row__position">Posi&shy;ción</div>
      <div class="hor-bar-chart__title-row__organization-name">Enti&shy;dades<br>contra&shy;tantes</div>
      <div class="hor-bar-chart__title-row__register-number">{{ chartLabels.xAxisLabel }}</div>
    </div>

    <div class="hor-bar-chart__content-part">
      <div v-for="(value, key, index) in sortedData" :key="index" class="hor-bar-chart__content-part__single-organization-row">
        <div class="hor-bar-chart__content-part__single-organization-row__position">{{ index + 1 }}</div>
        <div class="hor-bar-chart__content-part__single-organization-row__name-with-bar">
          <div class="hor-bar-chart__content-part__single-organization-row__name-with-bar__name">{{ key }}</div>
          <div class="hor-bar-chart__content-part__single-organization-row__name-with-bar__bar">
            <div
              :id="`${props.indicator}_bar_${index}`"
              class="hor-bar-chart__content-part__single-organization-row__name-with-bar__bar__colored-bar"
            >
              <q-tooltip max-width="75vw">
                {{ key }} <br> {{ value }} registros
              </q-tooltip>
            </div>
          </div>
        </div>
        <div class="hor-bar-chart__content-part__single-organization-row__register-number"><span>{{ value }}</span></div>
      </div>
    </div>
  </div>

</template>

<script setup>
import { computed, ref, onMounted, onUpdated, watchEffect } from 'vue';
import getChartLabels from 'src/composables/get_chart_labels';

const props = defineProps({
  data:      { type: Object, required: true },
  indicator: { type: String, required: true },
});

const data = computed(() => {
  return props?.data?.reduce((acc, item) => {
    acc[item.entidad_contratante] = +item.register_number;
    return acc;
  }, {});
});

const chartLabels = getChartLabels(props.indicator);

let sortedData = {};

const minDataValue = ref(0);
const maxDataValue = ref(0);

const calculateBarWidth = (minValue, maxValue, currentValue) => {
  let barWidth = '';

  switch (currentValue) {
    case minValue:
      barWidth = '10%';
      break;

    case maxValue:
      barWidth = '100%';
      break;

    default:
      barWidth = `${(1 - 0.9 * (maxValue - currentValue) / (maxValue - minValue)) * 100}%`;
      break;
  }

  return barWidth;
};

const sortByValues = obj => {
  const sortedEntries = Object.entries(obj).sort(([, a], [, b]) => b - a);
  return Object.fromEntries(sortedEntries);
};

const setColoredBarsWidth = () => {
  Object.values(sortedData).forEach((value, index) => {
    const coloredBarWidth = calculateBarWidth(minDataValue.value, maxDataValue.value, value);
    const coloredBar = document.querySelector(`#${props.indicator}_bar_${index}`);
    if (coloredBar) {
      coloredBar.style.width = coloredBarWidth;
    }
  });
};

watchEffect(() => {
  sortedData = sortByValues(data.value);
  minDataValue.value = Math.min(...Object.values(data.value));
  maxDataValue.value = Math.max(...Object.values(data.value));
});

onMounted(() => {
  setColoredBarsWidth();
});

onUpdated(() => {
  setColoredBarsWidth();
});

</script>

<style lang="scss">
@use './horizontal-bar-chart-component-stylesheet.scss';
</style>